//
//       32BitDIBNX
//
//    2004/ 9/17 ˁ@P
//

#include "classes.h"
#include <math.h>

SDIB32::SDIB32() { // ftHgRXgN^

	i32Width = 128;
	i32Height = 128;

	init();

}

SDIB32::SDIB32(const SDIB32 *t) { // RXgN^

	i32Width = 128;
	i32Height = 128;

	init();

	assign(t);

}

SDIB32::SDIB32(const SDIB32& t) { // Rs[RXgN^

	i32Width = 128;
	i32Height = 128;

	init();

	assign(&t);

}

bool SDIB32::assign(const SDIB32 *sbArg) {

	if (sbArg == NULL) {
		return false;
	}

	if (sbArg == this) {
		return true;
	}

	if (!reset(sbArg->getWidth(),sbArg->getHeight())) {
		return false;
	}

	// sNZYCrCbgobt@Rs[
	CopyMemory(lpPixels, sbArg->getPixels(), i32Width * i32Height * 4);
	CopyMemory(lpBuffer, sbArg->getBuffer(), i32Width * i32Height * 4);

	return true;

}

bool SDIB32::assign(const HBITMAP hbmpSrc) {

	if (hbmpSrc == NULL) {
		return false;
	}

	BITMAP bmp;

	/* BITMAP\̂Ƀrbg}bv̏擾 */
	if (GetObject(hbmpSrc, sizeof(bmp), &bmp) == 0) {
		return false;
	}

	if (bmp.bmWidth * bmp.bmHeight < 1) {
		return false;
	}

	if (!reset(bmp.bmWidth, bmp.bmHeight)) {
		return false;
	}

	BITMAPINFO biTmp;

	ZeroMemory(&biTmp, sizeof(biTmp));

	/* rbg}bṽsNZpobt@m */
	LPVOID lppxPixel = (LPVOID)new DWORD[bmp.bmWidth * bmp.bmHeight];

	/* rbg}bvsNZ擾p32rbgDIBBITMAPINFOݒ */
	biTmp.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biTmp.bmiHeader.biWidth = bmp.bmWidth;
	biTmp.bmiHeader.biHeight = bmp.bmHeight;
	biTmp.bmiHeader.biPlanes = 1;
	biTmp.bmiHeader.biBitCount = 32;

	HDC hdc = GetDC(NULL);

	/* sNZ擾 */
	GetDIBits(hdc, hbmpSrc, 0, bmp.bmHeight, lppxPixel, &biTmp, DIB_RGB_COLORS);

	ReleaseDC(NULL, hdc);

	/* sNZRs[ */
	CopyMemory(lpPixels, lppxPixel, bmp.bmWidth * bmp.bmHeight * 4);

	/* obt@ */
	delete [] lppxPixel;

	return true;

}

void SDIB32::init() {

	// DIBpm
	lpDIB=GlobalAlloc(GPTR, sizeof(BITMAPINFO) + i32Width * i32Height * 4 * 2);

	// |C^ݒ
	lpbiInfo = (LPBITMAPINFO)lpDIB;
	lpPixels = (PUI32)((LPBYTE)lpDIB + sizeof(BITMAPINFO));
	lpBuffer = lpPixels + i32Width * i32Height;

	// BITMAPINFOݒ
	lpbiInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	lpbiInfo->bmiHeader.biWidth = i32Width;
	lpbiInfo->bmiHeader.biHeight = i32Height;
	lpbiInfo->bmiHeader.biPlanes = 1;
	lpbiInfo->bmiHeader.biBitCount = 32;
	lpbiInfo->bmiHeader.biCompression = BI_RGB;

}

SDIB32& SDIB32::operator=(const SDIB32& t) { // =ZqI[o[[h

	if (this != &t) {
		assign(&t);
	}

	return *this;

}

bool SDIB32::reset(I32 i32W,I32 i32H) {

	if (i32W < 0 || i32H < 0) {
		return false;
	}

	// DIBpĊm
	if (i32W != i32Width || i32H != i32Height) {

		LPVOID lpTmp = GlobalAlloc(GPTR, sizeof(BITMAPINFO) + i32W * i32H * 4 * 2);

		if (lpTmp==NULL) { // mێsȂ炻̂܂ܖ߂
			return false;
		}

		// VTCYɐݒύX
		i32Width = i32W;
		i32Height = i32H;

		// ȑODIBJA|C^XV
		GlobalFree(lpDIB);
		lpDIB = lpTmp;

	} else {
		ZeroMemory(lpDIB, sizeof(BITMAPINFO) + i32W * i32H * 4 * 2);
	}

	// |C^ݒ
	lpbiInfo = (LPBITMAPINFO)lpDIB;
	lpPixels = (LPDWORD)((LPBYTE)lpDIB+sizeof(BITMAPINFO));
	lpBuffer = lpPixels + i32Width * i32Height;

	// BITMAPINFOݒ
	lpbiInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	lpbiInfo->bmiHeader.biWidth = i32Width;
	lpbiInfo->bmiHeader.biHeight = i32Height;
	lpbiInfo->bmiHeader.biPlanes = 1;
	lpbiInfo->bmiHeader.biBitCount = 32;
	lpbiInfo->bmiHeader.biCompression = BI_RGB;

	return true;

}

void SDIB32::draw(HDC hdc, I32 iX, I32 iY, double lfV) const { // DIB`

	StretchDIBits(hdc, iX, iY, (I32)(i32Width * lfV), (I32)(i32Height * lfV),
	  0, 0, i32Width, i32Height, lpPixels, lpbiInfo, DIB_RGB_COLORS, SRCCOPY);

}

void SDIB32::draw(HDC hdc, I32 iX, I32 iY, I32 iX2, I32 iY2) const { // DIB`

	StretchDIBits(hdc, iX, iY, iX2, iY2, 0, 0, i32Width, i32Height,
	  lpPixels, lpbiInfo, DIB_RGB_COLORS, SRCCOPY);

}

I32 SDIB32::getWidth() const { // 擾

	return i32Width;

}

I32 SDIB32::getHeight() const { // 擾

	return i32Height;

}

I32 SDIB32::getColors() const { // rbg}bv̐F擾

	UI32 u32Pixel;
	I32 i, j, i32Bit, i32Byte, i32Count = 0;
	PUI8 fColors;

	// 16MBit̃tÖ쐬
	fColors = (PUI8)GlobalAlloc(GPTR,256 * 256 * 32);

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			u32Pixel = getRGB(j, i);

			/* u32Pixelrbgڂ̈ʒuvZ */
			i32Byte = u32Pixel / 8;
			i32Bit = u32Pixel % 8;

			/* tÖdwPixelrbgڂ */
			if ((fColors[i32Byte] & (1 << i32Bit)) == 0) {

				/* tÖdwPixelrbgڂ𗧂Ă */
				fColors[i32Byte] = fColors[i32Byte]|(1 << i32Bit);
				i32Count++; /* FJE^XV */

			}

	}

	GlobalFree(fColors);

	return i32Count;

}

LPBITMAPINFO SDIB32::getInfo() const { return lpbiInfo; }

PUI32 SDIB32::getPixels() const {

	return lpPixels;

}

PUI32 SDIB32::getBuffer() const {

	return lpBuffer;

}

UI32 SDIB32::getRGB(I32 i32X,I32 i32Y) const { // (dwX,dwY)̐F擾

	if (i32X >= i32Width || i32Y >= i32Height) {
		return 0;
	}

	return lpPixels[i32X + i32Y * i32Width];

}

UI8 SDIB32::getR(I32 i32X, I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return (UI8)((getRGB(i32X,i32Y) & 0x00ff0000) >>16);
	} else {
		return 0;
	}

}

UI8 SDIB32::getG(I32 i32X, I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return (UI8)((getRGB(i32X, i32Y) & 0x0000ff00) >> 8);
	} else {
		return 0;
	}

}

UI8 SDIB32::getB(I32 i32X,I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return (UI8)(getRGB(i32X, i32Y) & 0x000000ff);
	} else {
		return 0;
	}

}

bool SDIB32::setRGB(I32 i32X, I32 i32Y, UI32 u32Val) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	lpPixels[i32X + i32Y * i32Width] = u32Val;

	return true;

}

bool SDIB32::setR(I32 i32X, I32 i32Y, I32 i32R) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	if (i32R<0) {
		i32R=0;
	}

	if (i32R>255) {
		i32R=255;
	}

	lpPixels[i32X + i32Y * i32Width] &= 0x0000ffff;
	lpPixels[i32X + i32Y * i32Width] += i32R << 16;

	return true;

}

bool SDIB32::setG(I32 i32X, I32 i32Y, I32 i32G) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	if (i32G<0) {
		i32G=0;
	}

	if (i32G>255) {
		i32G=255;
	}

	lpPixels[i32X + i32Y * i32Width] &= 0x00ff00ff;
	lpPixels[i32X + i32Y * i32Width] += i32G << 8;

	return true;

}

bool SDIB32::setB(I32 i32X, I32 i32Y, I32 i32B) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	if (i32B<0) {
		i32B=0;
	}

	if (i32B>255) {
		i32B=255;
	}

	lpPixels[i32X + i32Y * i32Width] &= 0x00ffff00;
	lpPixels[i32X + i32Y * i32Width] += i32B;

	return true;

}

UI8 SDIB32::getY(I32 i32X, I32 i32Y) const {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return 0;
	}

	double lfY = 0.299 * getR(i32X, i32Y) + 0.587 * getG(i32X, i32Y) + 0.114 * getB(i32X, i32Y);

	if (lfY < 0) {
		lfY = 0;
	}

	if (lfY > 255) {
		lfY = 255;
	}

	return (UI8)lfY;

}

UI32 SDIB32::getBufferVal(I32 i32X, I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return lpBuffer[i32X + i32Y * i32Width];
	} else {
		return 0;
	}

}

UI8 SDIB32::getBuffer1(I32 i32X, I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return (UI8)((getBufferVal(i32X, i32Y) & 0x00ff0000) >> 16);
	} else {
		return 0;
	}

}

UI8 SDIB32::getBuffer2(I32 i32X, I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return (UI8)((getBufferVal(i32X, i32Y) & 0x0000ff00) >> 8);
	} else {
		return 0;
	}

}

UI8 SDIB32::getBuffer3(I32 i32X, I32 i32Y) const {

	if (i32X >= 0 && i32X < i32Width && i32Y >= 0 && i32Y < i32Height) {
		return (UI8)(getBufferVal(i32X, i32Y) & 0x000000ff);
	} else {
		return 0;
	}

}

bool SDIB32::setBufferVal(I32 i32X, I32 i32Y, UI32 u32Val) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	lpBuffer[i32X + i32Y * i32Width] = u32Val;

	return true;

}

bool SDIB32::setBuffer1(I32 i32X, I32 i32Y, I32 i32Val) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	if (i32Val < 0) {
		i32Val = 0;
	}

	if (i32Val > 255) {
		i32Val = 255;
	}

	lpBuffer[i32X + i32Y * i32Width] &= 0x0000ffff;
	lpBuffer[i32X + i32Y * i32Width] += i32Val << 16;

	return true;

}

bool SDIB32::setBuffer2(I32 i32X, I32 i32Y, I32 i32Val) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	if (i32Val < 0) {
		i32Val = 0;
	}

	if (i32Val > 255) {
		i32Val = 255;
	}

	lpBuffer[i32X + i32Y * i32Width] &= 0x00ff00ff;
	lpBuffer[i32X + i32Y * i32Width] += i32Val << 8;

	return true;

}

bool SDIB32::setBuffer3(I32 i32X, I32 i32Y, I32 i32Val) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height) {
		return false;
	}

	if (i32Val < 0) {
		i32Val = 0;
	}

	if (i32Val > 255) {
		i32Val = 255;
	}

	lpBuffer[i32X + i32Y * i32Width] &= 0x00ffff00;
	lpBuffer[i32X + i32Y * i32Width] += i32Val;

	return true;

}

bool SDIB32::Filter9(FILTER9INFO *f9Info) {

	I32 i, j, k, l;
	UI32 u32Pixel;
	double lfR, lfG, lfB;
	PUI32 lpWrk;

	if (f9Info->lfDiv == 0 || f9Info->lfDiv > 999) {
		return false;
	}

	lpWrk = (PUI32)GlobalAlloc(GPTR, i32Width * i32Height * 4);

	CopyMemory(lpWrk, lpPixels, i32Width * i32Height * 4);

	for (i = 1;i < i32Height - 1;i++) /* tB^ */
		for (j = 1;j < i32Width - 1;j++) {

			lfR = 0;
			lfG = 0;
			lfB = 0;

			for (k = 0;k < 3;k++) /* RGBe̒lsl|ĉZ */
				for (l = 0;l < 3;l++) {

					u32Pixel = getRGB(j + l - 1,i + k - 1);
					lfR += (double)((u32Pixel & 0x00ff0000) >> 16) * f9Info->lfMatrix[l + k * 3];
					lfG += (double)((u32Pixel & 0x0000ff00) >> 8) * f9Info->lfMatrix[l + k * 3];
					lfB += (double)(u32Pixel & 0x000000ff) * f9Info->lfMatrix[l + k * 3];

				}

			lfR = f9Info->lfAdd + lfR / f9Info->lfDiv;
			lfG = f9Info->lfAdd + lfG / f9Info->lfDiv;
			lfB = f9Info->lfAdd + lfB / f9Info->lfDiv;

			if (lfR < 0) {
				lfR = 0;
			}

			if (lfR > 255) {
				lfR = 255;
			}

			if (lfG < 0) {
				lfG = 0;
			}

			if (lfG > 255) {
				lfG = 255;
			}

			if (lfB < 0) {
				lfB = 0;
			}

			if (lfB > 255) {
				lfB = 255;
			}

			lpWrk[j + i * i32Width] = (UI32)lfR * 65536 + (DWORD)lfG * 256 + (DWORD)lfB;

		}

	CopyMemory(lpPixels, lpWrk, i32Width * i32Height * 4);

	GlobalFree(lpWrk);

	return true;

}

bool SDIB32::resize(I32 i32Wid2, I32 i32Hei2) { // gk

	I32 i32SX, i32EX, i32SY, i32EY, i, j, k, l, i32OWid, i32OHei;
	PUI32 lpOPix;
	double lfR, lfG, lfB, lfSum, lfXW, lfYW, lfXRate, lfYRate;

	// Ɨpobt@mۂA摜Rs[
	lpOPix = (PUI32)GlobalAlloc(GPTR, i32Width * i32Height * 4);
	CopyMemory(lpOPix, lpPixels, i32Width * i32Height * 4);

	lfXRate = (double)i32Wid2 / (double)i32Width;
	lfYRate = (double)i32Hei2 / (double)i32Height;
	i32OWid = i32Width;
	i32OHei = i32Height;

	if (!reset(i32Wid2, i32Hei2)) {

		GlobalFree(lpOPix);
		return false;

	}

	for (i = 0;i < i32Height;i++) // gk
		for (j = 0;j < i32Width;j++) {

			// (j,i)ɑΉ錳摜̃sNZvZ
			i32SX = (I32)floor(j * (1 / lfXRate));
			i32EX = (I32)ceil((j + 1) * (1 / lfXRate)) - 1;
			i32SY = (I32)floor(i * (1 / lfYRate));
			i32EY = (I32)ceil((i + 1) * (1 / lfYRate)) - 1;

			lfR = 0;
			lfG = 0;
			lfB = 0;
			lfSum = 0;

			for (k = i32SY;k < i32EY + 1;k++)
				for (l = i32SX;l < i32EX + 1;l++) { // ܂܂sNZ̐v

					if (l == i32SX) { // ŏ̃sNZ
						lfXW=(l + 1) * lfXRate - floor(l * lfXRate);
					} else if (l == i32EX) { // Ō̃sNZ
						lfXW = (j + 1) - (l * lfXRate);
					} else { // Ԃ̃sNZ
						lfXW = lfXRate;
					}

					if (k == i32SY) { // ŏ̃sNZ
						lfYW = (k + 1) * lfYRate - floor(k * lfYRate);
					} else if (k == i32EY) { // Ō̃sNZ
						lfYW=(i + 1) - (k * lfYRate);
					} else { // Ԃ̃sNZ
						lfYW = lfYRate;
					}

					if (l < i32OWid && k < i32OHei) {

						lfR += ((lpOPix[l + k * i32OWid] & 0xff0000) >> 16) * lfXW * lfYW;
						lfG += ((lpOPix[l + k * i32OWid] & 0xff00) >> 8) * lfXW * lfYW;
						lfB += (lpOPix[l + k * i32OWid] & 0xff) * lfXW * lfYW;

						lfSum += lfXW * lfYW;

					}

				}

			// gksNZ̐ݒ
			setR(j, i, (I32)(lfR / lfSum));
			setG(j, i, (I32)(lfG / lfSum));
			setB(j, i, (I32)(lfB / lfSum));

		}

	GlobalFree(lpOPix);

	return true;

}

bool SDIB32::setRGB(SDIB32 *sb) {

	if (sb == NULL || sb->getWidth() != i32Width || sb->getHeight() != i32Height) {
		return false;
	}

	CopyMemory(lpPixels, sb->getPixels(), i32Width * i32Height * 4);

	return true;

}

void SDIB32::setYUVtoBuffer() {

	I32 y, u, v;
	double r, g, b;

	for (I32 i = 0;i < i32Height;i++) /* sNZ񂩂YCrCbobt@쐬 */
		for (I32 j = 0;j < i32Width;j++) {

			r = getR(j, i);
			g = getG(j, i);
			b = getB(j, i);

			y = (I32)(0.299 * r + 0.587 * g + 0.114 * b);
			u = (I32)(0.5 * r - 0.419 * g - 0.081 * b) + 128;
			v = (I32)(-0.169 * r - 0.331 * g + 0.5 * b) + 128;

			if (y > 255) {
				y = 255;
			}

			if (u < 0) {
				u = 0;
			}

			if (u > 255) {
				u = 255;
			}

			if (v < 0) {
				v = 0;
			}

			if (v > 255) {
				v = 255;
			}

			setBuffer1(j, i, y);
			setBuffer2(j, i, u);
			setBuffer3(j, i, v);

		}

}

void SDIB32::setRGBtoPixels() {

	I32 y, u, v, r, g, b;

	for (I32 i = 0;i < i32Height;i++)
		for (I32 j = 0;j < i32Width;j++) {

			y = getBuffer1(j, i);
			u = getBuffer2(j, i) - 128;
			v = getBuffer3(j, i) - 128;

			r = (I32)(y + 1.402 * u);
			g = (I32)(y - 0.714 * u - 0.344 * v);
			b = (I32)(y + 1.772 * v);

			setR(j, i, r);
			setG(j, i, g);
			setB(j, i, b);

		}

}

void SDIB32::unsharp(I32 i32Range, double lfV) {

	I32 r, g, b, r1, g1, b1, r2, g2, b2, dr, dg, db, i, j, k, l, v;

	LPDWORD lpWrk1 = (LPDWORD)GlobalAlloc(GPTR, i32Width * i32Height * 4);

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			r = g = b = v = 0;

			for (k = -i32Range; k <= i32Range;k++)
				for (l = -i32Range;l <= i32Range;l++)
					if (j + l >= 0 && j + l < i32Width && i + k >= 0 && i + k < i32Height) {

						int d = k * k + l * l;

						int dv = 4 - d;

						if (dv < 1) {
							dv = 1;
						}

						r += getR(j + l, i + k) * dv;
						g += getG(j + l, i + k) * dv;
						b += getB(j + l, i + k) * dv;

						v += dv;

					}

			r /= v;
			g /= v;
			b /= v;

			lpWrk1[j + i * i32Width] = (r << 16) + (g << 8) + b;

		}

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			r1 = getR(j, i);
			g1 = getG(j, i);
			b1 = getB(j, i);

			r2 = (lpWrk1[j + i * i32Width] & 0x00ff0000) >> 16;
			g2 = (lpWrk1[j + i * i32Width] & 0x0000ff00) >> 8;
			b2 = lpWrk1[j + i * i32Width] & 0x000000ff;

			dr = r1 - r2;
			dg = g1 - g2;
			db = b1 - b2;

			setR(j, i, (I32)(r1 + dr * lfV));
			setG(j, i, (I32)(g1 + dg * lfV));
			setB(j, i, (I32)(b1 + db * lfV));

		}

	GlobalFree(lpWrk1);

}

bool SDIB32::fog(I32 i32Range,double lfV) {

	double r, g, b, w;
	SDIB32 sbTmp = this;

	for (I32 i = 0;i < i32Height;i++)
		for (I32 j = 0;j < i32Width;j++) {

			r = g = b = w = 0;

			for (I32 k = -i32Range;k <= i32Range;k++)
				for (I32 l = -i32Range;l <= i32Range;l++)
					if (k == 0 && l == 0) {

						r += sbTmp.getR(j + l,i + k)*lfV;
						g += sbTmp.getG(j + l,i + k)*lfV;
						b += sbTmp.getB(j + l,i + k)*lfV;

						w += lfV;

					} else if (j + l >= 0 && j + l < i32Width && i + k >= 0 && i + k < i32Height) {

						r += sbTmp.getR(j + l, i + k);
						g += sbTmp.getG(j + l, i + k);
						b += sbTmp.getB(j + l, i + k);

						w += 1;

					}

			if (w > 0) {

				r = r / w;
				g = g / w;
				b = b / w;

				setR(j, i, (I32)r);
				setG(j, i, (I32)g);
				setB(j, i, (I32)b);

			}

		}

	return true;

}

bool SDIB32::median() {

	I32 i32Ys[9], w, r, g, b;
	SDIB32 sbTmp = this;

	for (I32 i = 0;i < i32Height;i++)
		for (I32 j = 0;j < i32Width;j++) {

			w = 0;

			for (I32 k = -1;k < 2;k++)
				for (I32 l = -1;l < 2;l++) {

					I32 x = j + l;
					I32 y = i + k;

					if (x >= 0 && x < i32Width && y >= 0 && y < i32Height) {

						i32Ys[l + 1 + (k + 1) * 3] = sbTmp.getY(x, y);

						w++;

					} else
						i32Ys[l + 1 + (k + 1) * 3]=-1;


				}

			for (I32 m = 0;m < 8;m++)
				for (I32 n = m + 1;n < 9;n++) {

					if (i32Ys[n] < i32Ys[m]) {

						I32 o = i32Ys[n];
						i32Ys[n] = i32Ys[m];
						i32Ys[m] = o;

					}

				}

			I32 i32Y = i32Ys[w / 2 + 4];

			for (I32 p = -1;p < 2;p++)
				for (I32 q = -1;q < 2;q++) {

					I32 x = j + q;
					I32 y = i + p;
		
					if (x >= 0 && x < i32Width && y >= 0 && y < i32Height
						&& sbTmp.getY(x, y) == i32Y) {

							r = sbTmp.getR(x, y);
							g = sbTmp.getG(x, y);
							b = sbTmp.getB(x, y);

							break;

					}

				}

			setR(j, i, r);
			setG(j, i, g);
			setB(j, i, b);

		}

		return true;

}

bool SDIB32::trim(I32 i32SX, I32 i32SY, I32 i32W, I32 i32H) {

	if (i32SX < 0 || i32SX >= i32Width - 1 || i32SY < 0 || i32SY >= i32Height - 1
		|| i32W < 1 || i32H < 1) {
		return false;
	}

	SDIB32 sbTmp = this;

	I32 i32Wid = i32W,i32Hei = i32H;

	if (i32SX + i32W > i32Width) {
		i32Wid = i32Width - i32SX;
	}

	if (i32SY + i32H > i32Height) {
		i32Hei = i32Height - i32SY;
	}

	reset(i32Wid, i32Hei);

	for (int i = 0;i < i32Hei;i++)
		for (int j = 0;j < i32Wid;j++) {
			setRGB(j, i, sbTmp.getRGB(j + i32SX, i + i32SY));
		}

	return true;

}

bool SDIB32::trimRGB() {

	for (I32 i = 0;i < i32Height;i++)
		for (I32 j = 0;j < i32Width;j++) {

			PUI8 lpTmp = (PUI8)(getPixels() + j + i * i32Width);

			lpTmp[3] = 0;

		}

	return true;

}

bool SDIB32::mix(I32 i32X, I32 i32Y, I32 i32A) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height ||i32A < 1) {
		return false;
	}

	I32 i, j, n = 0, r = 0, g = 0, b = 0;

	for (i = i32Y - i32A;i <= i32Y + i32A;i++)
		for (j=i32X-i32A;j<=i32X+i32A;j++)
			if (j >= 0 && j < i32Width && i >= 0 && i < i32Height) {

				r += getR(j, i);
				g += getG(j, i);
				b += getB(j, i);

				n++;

			}

	setR(i32X, i32Y, (int)(r / n));
	setG(i32X, i32Y, (int)(g / n));
	setB(i32X, i32Y, (int)(b / n));

	return true;

}

bool SDIB32::mix(I32 i32X, I32 i32Y, I32 i32A, I32 i32P) {

	if (i32X < 0 || i32X >= i32Width || i32Y < 0 || i32Y >= i32Height ||i32A < 1 || i32P < 1) {
		return false;
	}

	I32 i, j, n = 0, r = 0, g = 0, b = 0;

	for (i = i32Y - i32A;i <= i32Y + i32A;i++)
		for (j=i32X-i32A;j<=i32X+i32A;j++)
			if (j >= 0 && j < i32Width && i >= 0 && i < i32Height) {

				if (j == i32X && i == i32Y) {

					r += getR(j, i) * i32P;
					g += getG(j, i) * i32P;
					b += getB(j, i) * i32P;

					n += i32P;

				} else {

					r += getR(j, i);
					g += getG(j, i);
					b += getB(j, i);

					n++;

				}


			}

	setR(i32X, i32Y, (int)(r / n));
	setG(i32X, i32Y, (int)(g / n));
	setB(i32X, i32Y, (int)(b / n));

	return true;

}

SDIB32::~SDIB32() { // fXgN^

	GlobalFree(lpDIB); // DIBp

}
